# ManifoldDiff.jl

| **Documentation** | **Source** |
|:-----------------:|:----------------------:|
| [![](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliamanifolds.github.io/ManifoldDiff.jl/stable/) | [![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle) |
| [![](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliamanifolds.github.io/ManifoldDiff.jl/latest/) | [![CI](https://github.com/JuliaManifolds/ManifoldDiff.jl/workflows/CI/badge.svg)](https://github.com/JuliaManifolds/ManifoldDiff.jl/actions?query=workflow%3ACI+branch%3Amain) |
| | [![codecov.io](http://codecov.io/github/JuliaManifolds/ManifoldDiff.jl/coverage.svg?branch=main)](https://codecov.io/gh/JuliaManifolds/ManifoldDiff.jl/) |

Intrinsic differentiation tools on Riemannian manifolds. A part of the JuliaManifolds ecosystem.
See [`Manifolds.jl`](https://github.com/JuliaManifolds/Manifolds.jl)

#!/usr/bin/env julia
#
#

if "--help" ∈ ARGS
    println(
        """
     docs/make.jl

Render the `ManifoldDiff.jl` documentation with optional arguments

Arguments
* `--help`         - print this help and exit without rendering the documentation
* `--prettyurls`   – toggle the prettyurls part to true (which is otherwise only true on CI)
""",
    )
    exit(0)
end
# (a) if docs is not the current active environment, switch to it
# (from https://github.com/JuliaIO/HDF5.jl/pull/1020/) 
if Base.active_project() != joinpath(@__DIR__, "Project.toml")
    using Pkg
    Pkg.activate(@__DIR__)
    Pkg.develop(PackageSpec(; path = (@__DIR__) * "/../"))
    Pkg.resolve()
    Pkg.instantiate()
end

using ManifoldsBase, ManifoldDiff
using Documenter, DocumenterCitations

bib = CitationBibliography(joinpath(@__DIR__, "src", "references.bib"); style = :alpha)
makedocs(;
    format = Documenter.HTML(;
        prettyurls = (get(ENV, "CI", nothing) == "true") || ("--prettyurls" ∈ ARGS),
        assets = ["assets/favicon.ico", "assets/citations.css"],
    ),
    modules = [ManifoldDiff],
    authors = "Seth Axen, Mateusz Baran, Ronny Bergmann, and contributors.",
    sitename = "ManifoldDiff.jl",
    pages = [
        "Home" => "index.md",
        "Usage" => "basic_usage.md",
        "Backends" => "backends.md",
        "Library of functions" => "library.md",
        "Internals" => "internals.md",
        "Literature" => "references.md",
    ],
    plugins = [bib],
    warnonly = [:autodocs_block],
)
deploydocs(
    repo = "github.com/JuliaManifolds/ManifoldDiff.jl.git",
    push_preview = true,
    devbranch = "main",
)

using Manifolds, ManifoldsBase, ManifoldDiff, Test

@testset "Derivatives" begin
    M = Sphere(2)
    p = [0.0, 0.0, 1.0]
    q = [0.0, 1.0, 0.0]
    r = [1.0, 0.0, 0.0]
    @testset "Geodesic" begin
        X = log(M, p, q)
        s = geodesic(M, p, X, 0.5)
        Y = zero_vector(M, p)
        ManifoldDiff.geodesic_derivative!(M, Y, p, X, 0.5)
        Z = ManifoldDiff.geodesic_derivative(M, p, X, 0.5)
        sol = parallel_transport_to(M, p, X, s)
        @test isapprox(M, s, sol, Y)
        @test isapprox(M, s, sol, Z)

        ManifoldDiff.shortest_geodesic_derivative!(M, Y, p, q, 0.5)
        Z = ManifoldDiff.shortest_geodesic_derivative(M, p, q, 0.5)
        sol = parallel_transport_to(M, p, X, s)
        @test isapprox(M, s, sol, Y)
        @test isapprox(M, s, sol, Z)
    end
end

@doc raw"""
    y = prox_distance(M::AbstractManifold, λ::Real, p_data, p [, r=2])
    prox_distance!(M::AbstractManifold, q, λ::Real, p_data, p [, r=2])

Compute the proximal map ``\operatorname{prox}_{λf}`` with
parameter λ of ``f(p) = \frac{1}{r}d_{\mathcal M}^r(p_{\mathrm{data}},p)``.
For the in-place variant the computation is done in place of `q`.

# Input
* `M`      a manifold `M`
* `λ`      the prox parameter, a positive real number.
* `p_data` a point on `M`.
* `p`      the argument of the proximal map
* `r`      (`2`) exponent of the distance.

# Output
* `q` – the result of the proximal map of ``f``

For more details see [WeinmannDemaretStorath:2014](@cite)
"""
function prox_distance(M::AbstractManifold, λ::Real, p_data, p, r::Int = 2)
    d = distance(M, p_data, p)
    if r == 2
        t = λ / (1 + λ)
    elseif r == 1
        t = (λ < d) ? λ / d : 1.0
    else
        throw(
            ErrorException(
                "Proximal Map of distance(M, p_data, p) not implemented for an exponent $(r) (requires 1 or 2)",
            ),
        )
    end
    return shortest_geodesic(M, p, p_data, t)
end
function prox_distance!(M::AbstractManifold, q, λ::Real, p_data, p, r::Int = 2)
    d = distance(M, p_data, p)
    if r == 2
        t = λ / (1 + λ)
    elseif r == 1
        t = (λ < d) ? λ / d : 1.0
    else
        throw(
            ErrorException(
                "Proximal Map of distance(M, p_data, p) not implemented for an exponent $(r) (requires 1 or 2)",
            ),
        )
    end
    return shortest_geodesic!(M, q, p, p_data, t)
end

@doc raw"""
    abstract type AbstractProjector end

An abstract type for projectors on a tangent space $T_pM$ for fixed values of `p` and `M`.
Calling a projector on a tangent vector returns a new tangent vector:

    (Π::AbstractProjector)(X) -> Y

Projectors assume that `X` is a valid vector from $T_pM$.
"""
abstract type AbstractProjector end

@doc raw"""
    diagonalizing_projectors(M::AbstractManifold, p, X)

Compute eigenvalues of the Jacobi operator $Y → R(Y,X)X$, where $R$ is the curvature
endomorphism, together with projectors onto eigenspaces of the operator.
Projectors are objects of subtypes of [`AbstractProjector`](@ref).

By default constructs projectors using the [`DiagonalizingOrthonormalBasis`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/bases.html#ManifoldsBase.DiagonalizingOrthonormalBasis).
"""
function diagonalizing_projectors(M::AbstractManifold, p, X)
    B = get_basis(M, p, DiagonalizingOrthonormalBasis(X))
    N = length(B.data.eigenvalues)
    return map(
        i -> (B.data.eigenvalues[i], ProjectorOntoVector(M, p, B.data.vectors[i])),
        1:N,
    )
end

"""
    ProjectorOntoVector{TM<:AbstractManifold,TP,TX}

A structure that represents projector onto the subspace of the tangent space at `p`
from manifold `M` spanned by tangent vector `X` of unit norm.

# Constructor

ProjectorOntoVector(M::AbstractManifold, p, X)
"""
struct ProjectorOntoVector{TM<:AbstractManifold,TP,TX} <: AbstractProjector
    M::TM
    p::TP
    X::TX
end

function (Π::ProjectorOntoVector)(X)
    return inner(Π.M, Π.p, X, Π.X) * Π.X
end

"""
    CoprojectorOntoVector{TM<:AbstractManifold,TP,TX}


A structure that represents projector onto the subspace of the tangent space at `p`
from manifold `M` othogonal to vector `X` of unit norm.

# Constructor

CoprojectorOntoVector(M::AbstractManifold, p, X)
"""
struct CoprojectorOntoVector{TM<:AbstractManifold,TP,TX} <: AbstractProjector
    M::TM
    p::TP
    X::TX
end

function (Π::CoprojectorOntoVector)(X)
    return X - inner(Π.M, Π.p, X, Π.X) * Π.X
end

struct IdentityProjector <: AbstractProjector end

(::IdentityProjector)(X) = X

"""
    ExplicitEmbeddedBackend{TF<:NamedTuple}

A backend to use with the [`RiemannianProjectionBackend`](@ref) or the [`TangentDiffBackend`](@ref),
when you have explicit formulae for the gradient in the embedding available.


# Constructor
    ExplicitEmbeddedBackend(M::AbstractManifold; kwargs)

Construct an [`ExplicitEmbeddedBackend`](@ref) in the embedding `M`,
where currently the following keywords may be used

* `gradient` for a(n allocating) gradient function `gradient(M, p)` defined in the embedding
* `gradient!` for a mutating gradient function `gradient!(M, X, p)`.

Note that the gradient functions are defined on the embedding manifold `M` passed to the Backend as well
"""
struct ExplicitEmbeddedBackend{TM<:AbstractManifold,TF<:NamedTuple}
    manifold::TM
    functions::TF
end
function ExplicitEmbeddedBackend(M::TM; kwargs...) where {TM<:AbstractManifold}
    return ExplicitEmbeddedBackend{TM,typeof(values(kwargs))}(M, values(kwargs))
end

function _gradient(f, p, e::ExplicitEmbeddedBackend)
    g = get(e.functions, :gradient, Missing())
    g === missing &&
        throw(MissingException("The provided Embedded backend does not provide a gradient"))
    return g(e.manifold, p)
end

function _gradient!(f, X, p, e::ExplicitEmbeddedBackend)
    g! = get(e.functions, :gradient!, Missing())
    g! === missing && throw(
        MissingException(
            "The provided Embedded backend does not provide a mutating gradient",
        ),
    )
    g!(e.manifold, X, p)
    return X
end

using Manifolds, ManifoldDiff, Test

@testset "proximal maps" begin
    #
    # Distance
    p = [1.0, 0.0, 0.0]
    q = [0.0, 1.0, 0.0]
    M = Sphere(2)
    # Error for r != 1 or 2
    @test_throws ErrorException ManifoldDiff.prox_distance(M, 1.0, p, q, 3)
    @test_throws ErrorException ManifoldDiff.prox_distance!(M, p, 1.0, p, q, 3)
    # r = 1
    @test distance(
        M,
        ManifoldDiff.prox_distance(M, distance(M, p, q) / 2, p, q, 1),
        shortest_geodesic(M, p, q, 0.5),
    ) < eps()
    t = similar(p)
    ManifoldDiff.prox_distance!(M, t, distance(M, p, q) / 2, p, q, 1)
    @test t == ManifoldDiff.prox_distance(M, distance(M, p, q) / 2, p, q, 1)
    # r = 2
    ManifoldDiff.prox_distance!(M, t, 1.0, p, q, 2)
    @test t == ManifoldDiff.prox_distance(M, 1.0, p, q, 2)
    @test t == ManifoldDiff.prox_distance(M, 1.0, p, q) # 2 is also the default
    @test distance(M, t, shortest_geodesic(M, p, q, 0.5)) ≈ 0 atol = 1e-15
end

using Manifolds
using ManifoldsBase
using Random

@testset "Subgradients" begin
    M = Sphere(2)
    p = [0.0, 0.0, 1.0]
    q = [0.0, 1.0, 0.0]
    r = [1.0, 0.0, 0.0]
    @testset "Subgradient of the distance function" begin
        w = p
        X = zero_vector(M, w)
        Random.seed!(42)
        ManifoldDiff.subgrad_distance!(M, X, w, p, 1)
        Random.seed!(42)
        Y = ManifoldDiff.subgrad_distance(M, w, p, 1)
        @test Y == X
        @test is_vector(M, p, X)
        @test norm(M, p, X) ≤ 1.0
        ManifoldDiff.subgrad_distance!(M, Y, w, p, 1)
        @test is_vector(M, p, Y)
        @test norm(M, p, Y) ≤ 1.0
        Z = ManifoldDiff.grad_distance(M, p, r)
        W = ManifoldDiff.subgrad_distance(M, p, r)
        @test Z == W
        Z = ManifoldDiff.grad_distance(M, p, r, 2)
        W = ManifoldDiff.subgrad_distance(M, p, r, 2)
        @test Z == W

        X = zero_vector(M, p)
        ManifoldDiff.subgrad_distance!(M, X, p, q)
        Y = ManifoldDiff.subgrad_distance(M, p, q)
        Z = [0.0, 0.0, -π / 2] # known solution
        @test X == Y
        @test X == Z
        U = zero_vector(M, q)
        ManifoldDiff.subgrad_distance!(M, U, p, q, 1)
        V = ManifoldDiff.subgrad_distance(M, p, q, 1)
        W = -distance(M, q, p)^(-1) * log(M, q, p) # solution
        @test U == V
        @test U == W
    end
end

@doc raw"""
    Y = differential_shortest_geodesic_startpoint(M, p, q, t, X)
    differential_shortest_geodesic_startpoint!(M, Y, p, q, t, X)

Compute ``D_p γ(t;p,q)[η]`` (in place of `Y`).

# See also
[`differential_shortest_geodesic_endpoint`](@ref), [`jacobi_field`](@ref)
"""
function differential_shortest_geodesic_startpoint(M::AbstractManifold, p, q, t, X)
    return jacobi_field(M, p, q, t, X, βdifferential_shortest_geodesic_startpoint)
end
function differential_shortest_geodesic_startpoint!(M::AbstractManifold, Y, p, q, t, X)
    return jacobi_field!(M, Y, p, q, t, X, βdifferential_shortest_geodesic_startpoint)
end


@doc raw"""
    Y = differential_shortest_geodesic_endpoint(M, p, q, t, X)
    differential_shortest_geodesic_endpoint!(M, Y, p, q, t, X)

Compute ``D_qγ(t;p,q)[X]`` (in place of `Y`).

# See also
 [`differential_shortest_geodesic_startpoint`](@ref), [`jacobi_field`](@ref)
"""
function differential_shortest_geodesic_endpoint(M::AbstractManifold, p, q, t, X)
    return jacobi_field(M, q, p, 1 - t, X, βdifferential_shortest_geodesic_startpoint)
end
function differential_shortest_geodesic_endpoint!(M::AbstractManifold, Y, p, q, t, X)
    return jacobi_field!(M, Y, q, p, 1 - t, X, βdifferential_shortest_geodesic_startpoint)
end

@doc raw"""
    Z = differential_exp_basepoint(M, p, X, Y)
    differential_exp_basepoint!(M, Z, p, X, Y)

Compute ``D_p\exp_p X[Y]`` (in place of `Z`).

# See also
[`differential_exp_argument`](@ref), [`jacobi_field`](@ref)
"""
function differential_exp_basepoint(M::AbstractManifold, p, X, Y)
    return jacobi_field(M, p, exp(M, p, X), 1.0, Y, βdifferential_exp_basepoint)
end
function differential_exp_basepoint!(M::AbstractManifold, Z, p, X, Y)
    return jacobi_field!(M, Z, p, exp(M, p, X), 1.0, Y, βdifferential_exp_basepoint)
end

@doc raw"""
    Z = differential_exp_argument(M, p, X, Y)
    differential_exp_argument!(M, Z, p, X, Y)

Compute ``D_X\exp_pX[Y]`` (in place of `Z`).
Note that ``X ∈  T_X(T_p\mathcal M) = T_p\mathcal M`` is still a tangent vector.

# See also
 [`differential_exp_basepoint`](@ref), [`jacobi_field`](@ref)
"""
function differential_exp_argument(M::AbstractManifold, p, X, Y)
    return jacobi_field(M, p, exp(M, p, X), 1.0, Y, βdifferential_exp_argument)
end
function differential_exp_argument!(M::AbstractManifold, Z, p, X, Y)
    return jacobi_field!(M, Z, p, exp(M, p, X), 1.0, Y, βdifferential_exp_argument)
end

@doc raw"""
    Y = differential_log_basepoint(M, p, q, X)
    differential_log_basepoint!(M, Y, p, q, X)

computes ``D_p\log_pq[X]`` (in place of `Y`).

# See also
 [`differential_log_argument`](@ref), [`jacobi_field`](@ref)
"""
function differential_log_basepoint(M::AbstractManifold, p, q, X)
    return jacobi_field(M, p, q, 0.0, X, βdifferential_log_basepoint)
end
function differential_log_basepoint!(M::AbstractManifold, Y, p, q, X)
    return jacobi_field!(M, Y, p, q, 0.0, X, βdifferential_log_basepoint)
end

@doc raw"""
    Y = differential_log_argument(M, p, q, X)
    differential_log_argument!(M, Y, p, q, X)

computes ``D_q\log_pq[X]`` (in place of `Y`).

# See also
 [`differential_log_basepoint`](@ref), [`jacobi_field`](@ref)
"""
function differential_log_argument(M::AbstractManifold, p, q, X)
    # order of p and q has to be reversed in this call, cf. Persch, 2018 Lemma 2.3
    return jacobi_field(M, q, p, 1.0, X, βdifferential_log_argument)
end
function differential_log_argument!(M::AbstractManifold, Y, p, q, X)
    # order of p and q has to be reversed in this call, cf. Persch, 2018 Lemma 2.3
    return jacobi_field!(M, Y, q, p, 1.0, X, βdifferential_log_argument)
end

@doc raw"""
    differential_exp_argument_lie_approx(M::AbstractManifold, p, X, Y; n)

Approximate differential of exponential map based on Lie group exponential. The formula
reads (see Theorem 1.7 of [^Helgason1978])
```math
D_X \exp_{p}(X)[Y] = (\mathrm{d}L_{\exp_e(X)})_e\left(\sum_{k=0}^{n}\frac{(-1)^k}{(k+1)!}(\operatorname{ad}_X)^k(Y)\right)
```
where ``(\operatorname{ad}_X)^k(Y)`` is defined recursively as ``(\operatorname{ad}_X)^0(Y) = Y``,
``\operatorname{ad}_X^{k+1}(Y) = [X, \operatorname{ad}_X^k(Y)]``.

[^Helgason1978]:
    > S. Helgason, Differential Geometry, Lie Groups, and Symmetric Spaces, First Edition.
    > Academic Press, 1978.
"""
function differential_exp_argument_lie_approx(M::AbstractManifold, p, X, Y; n = 20)
    Z = allocate(X)
    return differential_exp_argument_lie_approx!(M, Z, p, X, Y; n)
end

function differential_exp_argument_lie_approx! end

@doc raw"""
    differential_inverse_retract_argument_fd_approx(
        M::AbstractManifold,
        p,
        q,
        X;
        retr::AbstractRetractionMethod = default_retraction_method(M),
        invretr::AbstractInverseRetractionMethod = default_inverse_retraction_method(M),
        h::Real=sqrt(eps(eltype(X))),
    )

Approximate the differential of the inverse retraction `invretr` using a finite difference
formula (see Eq. (16) in [Zimmermann:2020](@cite)
```math
\frac{\operatorname{retr}^{-1}_q(\operatorname{retr}_p(hX)) - \operatorname{retr}^{-1}_q(\operatorname{retr}_p(-hX))}{2h}
```
where ``h`` is the finite difference step `h`, ``\operatorname{retr}^{-1}`` is the inverse
retraction `invretr` and ``\operatorname{retr}`` is the retraction `retr`.
"""
function differential_inverse_retract_argument_fd_approx(
    M::AbstractManifold,
    p,
    q,
    X;
    retr::AbstractRetractionMethod = default_retraction_method(M),
    invretr::AbstractInverseRetractionMethod = default_inverse_retraction_method(M),
    h::Real = sqrt(eps(eltype(X))),
)
    Y = allocate_result(M, differential_inverse_retract_argument_fd_approx, X, p, q)
    differential_inverse_retract_argument_fd_approx!(M, Y, p, q, X; retr, invretr, h)
    return Y
end

function differential_inverse_retract_argument_fd_approx!(
    M::AbstractManifold,
    Y,
    p,
    q,
    X;
    retr::AbstractRetractionMethod = default_retraction_method(M),
    invretr::AbstractInverseRetractionMethod = default_inverse_retraction_method(M),
    h::Real = sqrt(eps(eltype(X))),
)
    p_tmp = retract(M, q, h * X, retr)
    inverse_retract!(M, Y, p, p_tmp, invretr)
    retract!(M, p_tmp, q, -h * X, retr)
    X_tmp = inverse_retract(M, p, p_tmp, invretr)
    Y .-= X_tmp
    Y ./= 2 * h
    return Y
end

function ManifoldDiff._derivative(f, p, backend::AbstractADType)
    return DI.derivative(f, backend, p)
end

function ManifoldDiff._derivative!(f, X, t, backend::AbstractADType)
    return DI.derivative!(f, X, backend, t)
end

function ManifoldDiff._gradient(f, p, backend::AbstractADType)
    return DI.gradient(f, backend, p)
end

function ManifoldDiff._gradient!(f, X, t, backend::AbstractADType)
    return DI.gradient!(f, X, backend, t)
end

function ManifoldDiff._jacobian(f, p, backend::AbstractADType)
    return DI.jacobian(f, backend, p)
end

function ManifoldDiff._jacobian!(f, X, p, backend::AbstractADType)
    return DI.jacobian!(f, X, backend, p)
end

function ManifoldDiff._hessian(f, p, backend::AbstractADType)
    return DI.hessian(f, backend, p)
end

# function ManifoldDiff._hessian!(f, X, p, backend::AbstractADType)
#     return DI.hessian!(f, X, backend, p)
# end

@doc raw"""
    βdifferential_shortest_geodesic_startpoint(κ,t,d)

weights for the [`jacobi_field`](@ref) corresponding to the differential of the geodesic
with respect to its start point ``D_x g(t;p,q)[X]``.
They are

```math
β(κ) = \begin{cases}
\frac{\sinh(d(1-t)\sqrt{-κ})}{\sinh(d\sqrt{-κ})}
&\text{ if }κ < 0,\\
1-t & \text{ if } κ = 0,\\
\frac{\sin((1-t)d\sqrt{κ})}{\sinh(d\sqrt{κ})}
&\text{ if }κ > 0.
\end{cases}
```

Due to a symmetry argument, these are also used to compute ``D_q g(t; p,q)[η]``

# See also

[`differential_shortest_geodesic_endpoint`](@ref), [`differential_shortest_geodesic_startpoint`](@ref), [`jacobi_field`](@ref)
"""
function βdifferential_shortest_geodesic_startpoint(κ, t, d)
    (d == 0) && return one(t) - t
    (κ < 0) && return sinh(sqrt(-κ) * (one(t) - t) * d) / sinh(sqrt(-κ) * d)
    (κ > 0) && return sin(sqrt(κ) * (one(t) - t) * d) / sin(sqrt(κ) * d)
    return one(t) - t # curvature zero
end
@doc raw"""
    βdifferential_exp_basepoint(κ,t,d)

weights for the [`jacobi_field`](@ref) corresponding to the differential of the geodesic
with respect to its start point ``D_p \exp_p X [Y]``. They are

```math
β(κ) = \begin{cases}
\cosh(\sqrt{-κ})&\text{ if }κ < 0,\\
1 & \text{ if } κ = 0,\\
\cos(\sqrt{κ}) &\text{ if }κ > 0.
\end{cases}
```

# See also

[`differential_exp_basepoint`](@ref), [`jacobi_field`](@ref)
"""
function βdifferential_exp_basepoint(κ, ::Number, d)
    (κ < 0) && return cosh(sqrt(-κ) * d)
    (κ > 0) && return cos(sqrt(κ) * d)
    return one(float(κ))
end
@doc raw"""
    βdifferential_exp_argument(κ,t,d)

weights for the [`jacobi_field`](@ref) corresponding to the differential of the geodesic
with respect to its start point ``D_X \exp_p X[Y]``. They are

```math
β(κ) = \begin{cases}
\frac{\sinh(d\sqrt{-κ})}{d\sqrt{-κ}}&\text{ if }κ < 0,\\
1 & \text{ if } κ = 0,\\
\frac{\sin(d\sqrt{κ})}{d\sqrt{κ}}&\text{ if }κ > 0.
\end{cases}
```

# See also

[`differential_exp_argument`](@ref), [`jacobi_field`](@ref)
"""
function βdifferential_exp_argument(κ, ::Number, d)
    (d == 0) && return one(float(κ))
    (κ < 0) && return sinh(sqrt(-κ) * d) / (d * sqrt((-κ)))
    (κ > 0) && return sin(sqrt(κ) * d) / (d * sqrt(κ))
    return one(float(κ)) # cuvature zero.
end
@doc raw"""
    βdifferential_log_basepoint(κ,t,d)

weights for the [`jacobi_field`](@ref) corresponding to the differential of the geodesic
with respect to its start point ``D_p \log_p q[X]``. They are

```math
β(κ) = \begin{cases}
-\sqrt{-κ}d\frac{\cosh(d\sqrt{-κ})}{\sinh(d\sqrt{-κ})}&\text{ if }κ < 0,\\
-1 & \text{ if } κ = 0,\\
-\sqrt{κ}d\frac{\cos(d\sqrt{κ})}{\sin(d\sqrt{κ})}&\text{ if }κ > 0.
\end{cases}
```

# See also

[`differential_log_argument`](@ref), [`differential_log_argument`](@ref), [`jacobi_field`](@ref)
"""
function βdifferential_log_basepoint(κ, ::Number, d)
    (d == 0) && return -one(float(κ))
    (κ < 0) && return -sqrt(-κ) * d * cosh(sqrt(-κ) * d) / sinh(sqrt(-κ) * d)
    (κ > 0) && return -sqrt(κ) * d * cos(sqrt(κ) * d) / sin(sqrt(κ) * d)
    return -one(float(κ)) # cuvature zero.
end
@doc raw"""
    βdifferential_log_argument(κ,t,d)

weights for the JacobiField corresponding to the differential of the logarithmic
map with respect to its argument ``D_q \log_p q[X]``. They are

```math
β(κ) = \begin{cases}
\frac{ d\sqrt{-κ} }{\sinh(d\sqrt{-κ})}&\text{ if }κ < 0,\\
1 & \text{ if } κ = 0,\\
\frac{ d\sqrt{κ} }{\sin(d\sqrt{κ})}&\text{ if }κ > 0.
\end{cases}
```

# See also

[`differential_log_basepoint`](@ref), [`jacobi_field`](@ref)
"""
function βdifferential_log_argument(κ, ::Number, d)
    (d == 0) && return one(float(κ))
    (κ < 0) && return sqrt(-κ) * d / sinh(sqrt(-κ) * d)
    (κ > 0) && return sqrt(κ) * d / sin(sqrt(κ) * d)
    return one(float(κ)) # curvature zero
end

@doc raw"""
    Y = adjoint_Jacobi_field(M, p, q, t, X, β)
    adjoint_Jacobi_field!(M, Y, p, q, t, X, β)

Compute the AdjointJacobiField ``J`` along the geodesic ``γ_{p,q}`` on the manifold
``\mathcal M`` with initial conditions (depending on the application)
``X ∈ T_{γ_{p,q}(t)}\mathcal M`` and weights ``β``. The result is a vector
``Y ∈ T_p\mathcal M``. The main difference to [`jacobi_field`](@ref) is the,
that the input `X` and the output `Y` switched tangent spaces.
The computation can be done in place of `Y`.

For details see [`jacobi_field`](@ref)
"""
function adjoint_Jacobi_field(M::AbstractManifold, p, q, t, X, β::Tβ) where {Tβ}
    Y = allocate_result(M, adjoint_Jacobi_field, X, p, q)
    return adjoint_Jacobi_field!(M, Y, p, q, t, X, β)
end
function adjoint_Jacobi_field!(M::AbstractManifold, Y, p, q, t, X, β::Tβ) where {Tβ}
    dpq = distance(M, p, q)
    if isapprox(M, p, q)
        copyto!(M, Y, p, X)
        Y .*= β(zero(t), t, dpq)
    else
        x = shortest_geodesic(M, p, q, t)
        zero_vector!(M, Y, p)
        projectors = diagonalizing_projectors(M, p, log(M, p, q) / dpq)
        tX = vector_transport_to(M, x, X, p, ParallelTransport())
        map(projectors) do proj
            ptX = proj[2](tX)
            return Y .+= β(proj[1], t, dpq) .* ptX
        end
    end
    return Y
end
function adjoint_Jacobi_field!(
    M::PowerManifoldNestedReplacing,
    Y,
    p,
    q,
    t,
    X,
    β::Tβ,
) where {Tβ}
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Y[i...] = adjoint_Jacobi_field(
            M.manifold,
            _read(M, rep_size, p, i),
            _read(M, rep_size, q, i),
            t,
            _read(M, rep_size, X, i),
            β,
        )
    end
    return Y
end
function adjoint_Jacobi_field!(M::AbstractPowerManifold, Y, p, q, t, X, β::Tβ) where {Tβ}
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        adjoint_Jacobi_field!(
            M.manifold,
            _write(M, rep_size, Y, i),
            _read(M, rep_size, p, i),
            _read(M, rep_size, q, i),
            t,
            _read(M, rep_size, X, i),
            β,
        )
    end
    return Y
end

@doc raw"""
    Y = jacobi_field(M, p, q, t, X, β)
    jacobi_field!(M, Y, p, q, t, X, β)

compute the Jacobi field ``J`` along the geodesic ``γ_{p,q}`` on the manifold ``\mathcal M`` with
initial conditions (depending on the application) ``X ∈ T_p\mathcal M`` and weights ``β``. The
result is a tangent vector `Y` from ``T_{γ_{p,q}(t)}\mathcal M``.
The computation can be done in place of `Y`.

# See also

[`adjoint_Jacobi_field`](@ref)
"""
function jacobi_field(M::AbstractManifold, p, q, t, X, β::Tβ) where {Tβ}
    Y = allocate_result(M, jacobi_field, X, p, q)
    return jacobi_field!(M, Y, p, q, t, X, β)
end
function jacobi_field!(M::AbstractManifold, Y, p, q, t, X, β::Tβ) where {Tβ}
    dpq = distance(M, p, q)
    if isapprox(M, p, q)
        copyto!(M, Y, p, X)
        Y .*= β(zero(t), t, dpq)
    else
        x = shortest_geodesic(M, p, q, t)
        zero_vector!(M, Y, p)
        projectors = diagonalizing_projectors(M, p, log(M, p, q) / dpq)
        map(projectors) do proj
            pX = proj[2](X)
            ptX = vector_transport_to(M, p, pX, x, ParallelTransport())
            return Y .+= β(proj[1], t, dpq) .* ptX
        end
    end

    return Y
end
function jacobi_field!(M::AbstractPowerManifold, Y, p, q, t, X, β::Tβ) where {Tβ}
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        jacobi_field!(
            M.manifold,
            _write(M, rep_size, Y, i),
            _read(M, rep_size, p, i),
            _read(M, rep_size, q, i),
            t,
            _read(M, rep_size, X, i),
            β,
        )
    end
    return Y
end
function jacobi_field!(M::PowerManifoldNestedReplacing, Y, p, q, t, X, β::Tβ) where {Tβ}
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Y[i...] = jacobi_field(
            M.manifold,
            _read(M, rep_size, p, i),
            _read(M, rep_size, q, i),
            t,
            _read(M, rep_size, X, i),
            β,
        )
    end
    return Y
end

using Manifolds, LinearAlgebra, PGFPlotsX, Colors, Contour, Random

#
# Settings
#
dark_mode = true

line_offset_brightness = 0.25
patch_opacity = 1.0
interface_patch_opacity = 0.66
#geo_opacity = dark_mode ? 0.66 : 0.5
geo_opacity = 0.66
geo_line_width = 30
mesh_line_width = 5
mesh_opacity = dark_mode ? 0.5 : 0.7
logo_colors = [(77, 100, 174), (57, 151, 79), (202, 60, 50), (146, 89, 163)] # Julia colors

rgb_logo_colors = map(x -> RGB(x ./ 255...), logo_colors)
rgb_logo_colors_bright =
    map(x -> RGB((1 + line_offset_brightness) .* x ./ 255...), logo_colors)
rgb_logo_colors_dark =
    map(x -> RGB((1 - line_offset_brightness) .* x ./ 255...), logo_colors)

out_file_prefix = dark_mode ? "logo-diff-dark" : "logo-diff"
out_file_ext = ".svg"

#
# Helping functions
#
polar_to_cart(r, θ) = (r * cos(θ), r * sin(θ))
cart_to_polar(x, y) = (hypot(x, y), atan(y, x))
normal_coord_to_vector(M, x, rθ, B) = get_vector(M, x, collect(polar_to_cart(rθ...)), B)
normal_coord_to_point(M, x, rθ, B) = exp(M, x, normal_coord_to_vector(M, x, rθ, B))

function plot_normal_coord!(ax, M, x, B, rs, θs; ncirc = 9, options = Dict(), kwargs...)
    for r in rs[2:(end - 1)]
        push!(
            ax,
            Plot3(
                options,
                Coordinates(map(θ -> Tuple(normal_coord_to_point(M, x, [r, θ], B)), θs)),
            ),
        )
    end
    for θ in range(0, 2π; length = ncirc)
        push!(
            ax,
            Plot3(
                options,
                Coordinates(map(r -> Tuple(normal_coord_to_point(M, x, [r, θ], B)), rs)),
            ),
        )
    end
    return ax
end

function plot_patch!(ax, M, x, B, r, θs; options = Dict())
    push!(
        ax,
        Plot3(
            options,
            Coordinates(map(θ -> Tuple(normal_coord_to_point(M, x, [r, θ], B)), θs)),
        ),
    )
    return ax
end

function plot_geodesic!(ax, M, x, y; n = 100, options = Dict())
    γ = shortest_geodesic(M, x, y)
    T = range(0, 1; length = n)
    push!(ax, Plot3(options, Coordinates(Tuple.(γ.(T)))))
    return ax
end

#
# Prepare document
#
resize!(PGFPlotsX.CUSTOM_PREAMBLE, 0)
push!(PGFPlotsX.CUSTOM_PREAMBLE, raw"\pgfplotsset{scale=6.0}")
push!(PGFPlotsX.CUSTOM_PREAMBLE, raw"\usetikzlibrary{arrows.meta}")
push!(PGFPlotsX.CUSTOM_PREAMBLE, raw"\pgfplotsset{roundcaps/.style={line cap=round}}")
push!(
    PGFPlotsX.CUSTOM_PREAMBLE,
    raw"\pgfplotsset{meshlinestyle/.style={dash pattern=on 1.8\pgflinewidth off 1.4\pgflinewidth, line cap=round}}",
)
if dark_mode
    push!(PGFPlotsX.CUSTOM_PREAMBLE, raw"\pagecolor{black}")
end
S = Sphere(2)

center = normalize([1, 1, 1])
x, y, z = eachrow(Matrix{Float64}(I, 3, 3))
γ1 = shortest_geodesic(S, center, z)
γ2 = shortest_geodesic(S, center, x)
γ3 = shortest_geodesic(S, center, y)
p1 = γ1(1)
p2 = γ2(1)
p3 = γ3(1)

#
# Setup Axes
if dark_mode
    tp = @pgf Axis({
        axis_lines = "none",
        axis_equal,
        view = "{135}{35}",
        zmin = -0.05,
        zmax = 1.0,
        xmin = 0.0,
        xmax = 1.0,
        ymin = 0.0,
        ymax = 1.0,
    })
else
    tp = @pgf Axis({
        axis_lines = "none",
        axis_equal,
        view = "{135}{35}",
        zmin = -0.05,
        zmax = 1.0,
        xmin = 0.0,
        xmax = 1.0,
        ymin = 0.0,
        ymax = 1.0,
    })
end
rs = range(0, π / 5; length = 6)
θs = range(0, 2π; length = 100)

#
# Plot manifold patches
patch_colors = rgb_logo_colors[2:end]
patch_colors_line = dark_mode ? rgb_logo_colors_bright[2:end] : rgb_logo_colors_dark[2:end]
base_points = [p1, p2, p3]
basis_vectors = [log(S, p1, p2), log(S, p2, p1), log(S, p3, p1)]
# Patches: 1=red, left, 2=green, top, 3=violet, right
# Interface patches
#=
for i in [2,]
    b = base_points[i]
    B = DiagonalizingOrthonormalBasis(basis_vectors[i])
    basis = get_basis(S, b, B)
    optionsP = @pgf {
        fill = patch_colors[i],
        draw = "none",
        opacity = interface_patch_opacity,
}
    plot_patch!(tp, S, b, basis, π / 5, θs; options = optionsP)
    optionsP =
        @pgf {
            fill = dark_mode ? "black" : "white",
            draw = "none",
            opacity = 1.0,
        }
    plot_patch!(tp, S, b, basis, 0.75 * π / 5, θs; options = optionsP)
end
=#
# Manifold patches
for i in [1, 3] # green
    x = base_points[i]
    B = DiagonalizingOrthonormalBasis(basis_vectors[i])
    basis = get_basis(S, x, B)
    optionsP = @pgf {fill = patch_colors[i], draw = "none", opacity = patch_opacity}
    plot_patch!(tp, S, x, basis, π / 5, θs; options = optionsP)
    optionsL = @pgf {
        meshlinestyle,
        color = dark_mode ? "white" : "black",
        line_width = mesh_line_width,
        opacity = mesh_opacity,
    }
    plot_normal_coord!(tp, S, x, basis, rs, θs; options = optionsL)
end

#
# Plot geodesics
options = @pgf {
    opacity = geo_opacity,
    "meshlinestyle",
    no_markers,
    roundcaps,
    line_width = geo_line_width,
    #color = dark_mode ? "white" : "black",
    color = rgb_logo_colors[1],
}
plot_geodesic!(tp, S, base_points[1], base_points[2]; options = options)
plot_geodesic!(tp, S, base_points[1], base_points[3]; options = options)
plot_geodesic!(tp, S, base_points[2], base_points[3]; options = options)
# Text labels

push!(
    tp,
    raw"\node [scale=60, yshift=.0325cm, xshift=.03cm, color=" *
    "$(dark_mode ? "white" : "black")] at ($(p2[1]), $(p2[2]), $(p2[3])) " *
    raw"{$\partial$};",
)
#push!(
#    tp,
#    raw"\node [scale=40, color=" *
#    "$(dark_mode ? "white" : "black")] at ($(p3[1]), $(p3[2]), $(p3[3])) " *
#    raw"{$\partial$};",
#)
#
# Export Logo.
out_file = "$(out_file_prefix)$(out_file_ext)"
pgfsave(out_file, tp)
pgfsave("$(out_file_prefix).pdf", tp)

using Manifolds, ManifoldDiff
using Test

using ManifoldDiff:
    differential_exp_argument,
    differential_exp_argument!,
    differential_exp_basepoint,
    differential_exp_basepoint!,
    differential_log_argument,
    differential_log_argument!,
    differential_log_basepoint,
    differential_log_basepoint!,
    differential_shortest_geodesic_endpoint,
    differential_shortest_geodesic_endpoint!,
    differential_shortest_geodesic_startpoint,
    differential_shortest_geodesic_startpoint!


@testset "Differentials" begin
    p = [1.0, 0.0, 0.0]
    q = [0.0, 1.0, 0.0]
    M = Sphere(2)
    X = log(M, p, q)
    X_qp = log(M, q, p)
    Y = similar(X)
    @testset "Differentials on Sn(2)" begin
        @test differential_log_basepoint(M, p, p, X) == -X
        differential_log_basepoint!(M, Y, p, p, X)
        @test Y == -X
        @test differential_log_basepoint(M, p, q, X) == -X
        differential_log_basepoint!(M, Y, p, q, X) == -X
        @test Y == -X
        @test differential_log_argument(M, p, p, X) == X
        differential_log_argument!(M, Y, p, p, X) == X
        @test Y == X
        @test differential_log_argument(M, p, q, X_qp) == -X
        differential_log_argument!(M, Y, p, q, X_qp)
        @test Y == -X
        @test differential_exp_basepoint(M, p, zero_vector(M, p), X) == X
        differential_exp_basepoint!(M, Y, p, zero_vector(M, p), X)
        @test Y == X
        @test norm(M, q, differential_exp_basepoint(M, p, X, X) - [-π / 2, 0.0, 0.0]) ≈ 0 atol =
            6 * 10^(-16)
        differential_exp_basepoint!(M, Y, p, X, X)
        @test norm(M, q, Y - [-π / 2, 0.0, 0.0]) ≈ 0 atol = 6 * 10^(-16)
        @test differential_exp_argument(M, p, zero_vector(M, p), X) == X
        differential_exp_argument!(M, Y, p, zero_vector(M, p), X) == X
        @test Y == X
        @test norm(M, q, differential_exp_argument(M, p, X, zero_vector(M, p))) ≈ 0
        differential_exp_argument!(M, Y, p, X, zero_vector(M, p))
        @test norm(M, q, Y) ≈ 0
        for t in [0, 0.15, 0.33, 0.66, 0.9]
            @test differential_shortest_geodesic_startpoint(M, p, p, t, X) == (1 - t) * X
            differential_shortest_geodesic_startpoint!(M, Y, p, p, t, X)
            @test Y == (1 - t) * X
            @test norm(
                M,
                p,
                differential_shortest_geodesic_endpoint(M, p, p, t, X) - t * X,
            ) ≈ 0 atol = 10.0^(-16)
            differential_shortest_geodesic_endpoint!(M, Y, p, p, t, X)
            @test norm(M, p, Y - t * X) ≈ 0 atol = 10.0^(-16)
        end
    end
    @testset "Differentials on Power of Sn(2)" begin
        for rep in [NestedPowerRepresentation(), NestedReplacingPowerRepresentation()]
            N = PowerManifold(M, rep, 3)
            pN = [p, q, p]
            qN = [p, p, q]
            V = [X, zero_vector(M, p), -X_qp]
            W = allocate(V)
            @test differential_log_argument(N, pN, qN, V) == [V[1], V[2], V[1]]
            differential_log_argument!(N, W, pN, qN, V)
            @test W == [V[1], V[2], V[1]]
        end
    end
    @testset "Differentials on SPD(2)" begin
        #
        # Single differentials on SPD
        M2 = SymmetricPositiveDefinite(2)
        p2 = [1.0 0.0; 0.0 1.0]
        X2 = [0.5 1.0; 1.0 0.5]
        q2 = exp(M2, p2, X2)
        # Test differentials (1) Dx of Log_xy
        @test norm(M2, p2, differential_log_basepoint(M2, p2, p2, X2) + X2) ≈ 0 atol =
            4 * 10^(-16)
        @test norm(M2, q2, differential_log_argument(M2, p2, q2, zero_vector(M2, p2))) ≈ 0 atol =
            4 * 10^(-16)
        @test norm(
            M2,
            p2,
            differential_exp_basepoint(M2, p2, zero_vector(M2, p2), X2) - X2,
        ) ≈ 0 atol = 4 * 10^(-16)
        @test norm(
            M2,
            p2,
            differential_exp_argument(M2, p2, zero_vector(M2, p2), X2) - X2,
        ) ≈ 0 atol = 4 * 10^(-16)

        @test norm(M2, q2, differential_exp_basepoint(M2, p2, X2, zero_vector(M2, p2))) ≈ 0 atol =
            4 * 10.0^(-16)
        @test norm(M2, q2, differential_exp_argument(M2, p2, X2, zero_vector(M2, p2))) ≈ 0 atol =
            4 * 10.0^(-16)
        # test coeff of log_basepoint, since it is not always expicitly used.
        @test ManifoldDiff.βdifferential_log_basepoint(-1.0, 1.0, 2.0) ≈
              -2 * cosh(2.0) / sinh(2.0)
    end
    @testset "Differentials on Euclidean(2)" begin
        M3 = Euclidean(2)
        x3 = [1.0, 2.0]
        ξ3 = [1.0, 0.0]
        @test norm(M3, x3, differential_exp_basepoint(M3, x3, ξ3, ξ3) - ξ3) ≈ 0 atol =
            4 * 10.0^(-16)
    end
    @testset "Differentials on the Circle" begin
        M = Circle()
        p = 0
        q = π / 4
        X = π / 8
        @test differential_log_argument(M, p, q, X) == X
    end
    @testset "Differentials on Euclidean()" begin
        M = Euclidean()
        p = 0
        q = π / 4
        X = π / 8
        @test differential_log_argument(M, p, q, X) == X
    end

    @testset "Differentials on ProductManifold" begin
        M = ProductManifold(Sphere(2), SymmetricPositiveDefinite(2))
        p = ArrayPartition([0.0, 0.0, 1.0], [1.0 0.0; 0.0 1.0])
        Xp = ArrayPartition([-0.5, 1.0, 0.0], [0.5 1.0; 1.0 0.5])
        q = exp(M, p, Xp)
        # Test differentials (1) Dx of Log_xy
        @test norm(M, p, differential_log_basepoint(M, p, p, Xp) + Xp) ≈ 0 atol =
            4 * 10^(-16)
        @test norm(M, q, differential_log_argument(M, p, q, zero_vector(M, p))) ≈ 0 atol =
            4 * 10^(-16)
        @test norm(M, p, differential_exp_basepoint(M, p, zero_vector(M, p), Xp) - Xp) ≈ 0 atol =
            4 * 10^(-16)
        @test norm(M, p, differential_exp_argument(M, p, zero_vector(M, p), Xp) - Xp) ≈ 0 atol =
            4 * 10^(-16)

        @test norm(M, q, differential_exp_basepoint(M, p, Xp, zero_vector(M, p))) ≈ 0 atol =
            4 * 10.0^(-16)
        @test norm(M, q, differential_exp_argument(M, p, Xp, zero_vector(M, p))) ≈ 0 atol =
            4 * 10.0^(-16)
    end
end

"""
    AbstractRiemannianDiffBackend

An abstract type for backends for differentiation.
"""
abstract type AbstractRiemannianDiffBackend end

@doc raw"""
    differential(M::AbstractManifold, f, t::Real, backend)
    differential!(M::AbstractManifold, f, X, t::Real, backend)

Compute the Riemannian differential of a curve $f: ℝ\to M$ on a manifold `M`
represented by function `f` at time `t` using the given backend.
It is calculated as the tangent vector equal to $\mathrm{d}f_t(t)[1]$.

The mutating variant computes the differential in place of `X`.
"""
differential(::AbstractManifold, ::Any, ::Real, ::AbstractRiemannianDiffBackend)

@doc raw"""
    gradient(M::AbstractManifold, f, p, backend::AbstractRiemannianDiffBackend)
    gradient!(M::AbstractManifold, f, X, p, backend::AbstractRiemannianDiffBackend)

Compute the Riemannian gradient ``∇f(p)`` of a real-valued function ``f:\mathcal M \to ℝ``
at point `p` on the manifold `M` using the specified [`AbstractRiemannianDiffBackend`](@ref).

The mutating variant computes the gradient in place of `X`.
"""
gradient(::AbstractManifold, ::Any, ::Any, ::AbstractRiemannianDiffBackend)

function differential!(
    M::AbstractManifold,
    f::Any,
    X,
    t,
    backend::AbstractRiemannianDiffBackend,
)
    return copyto!(X, differential(M, f, t, backend))
end

function gradient!(M::AbstractManifold, f, X, p, backend::AbstractRiemannianDiffBackend)
    return copyto!(X, gradient(M, f, p, backend))
end

@doc raw"""
    TangentDiffBackend <: AbstractRiemannianDiffBackend

A backend that uses tangent spaces and bases therein to derive an
intrinsic differentiation scheme.

Since it works in tangent spaces at argument and function value, methods might require a
retraction and an inverse retraction as well as a basis.

In the tangent space itself, this backend then employs a (Euclidean) backend.

# Constructor

    TangentDiffBackend(diff_backend)

where `diff_backend` is a (Euclidean) backend to be used on the tangent space.

With the keyword arguments

* `retraction` an [AbstractRetractionMethod](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/retractions.html) (`ExponentialRetraction` by default)
* `inverse_retraction` an [AbstractInverseRetractionMethod](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/retractions.html) `LogarithmicInverseRetraction` by default)
* `basis_arg` an [AbstractBasis](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/bases.html) (`DefaultOrthogonalBasis` by default)
* `basis_val` an [AbstractBasis](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/bases.html) (`DefaultOrthogonalBasis` by default)
"""
struct TangentDiffBackend{
    TAD,
    TR<:AbstractRetractionMethod,
    TIR<:AbstractInverseRetractionMethod,
    TBarg<:AbstractBasis,
    TBval<:AbstractBasis,
} <: AbstractRiemannianDiffBackend
    diff_backend::TAD
    retraction::TR
    inverse_retraction::TIR
    basis_arg::TBarg
    basis_val::TBval
end
function TangentDiffBackend(
    diff_backend::TAD;
    retraction::TR = ExponentialRetraction(),
    inverse_retraction::TIR = LogarithmicInverseRetraction(),
    basis_arg::TBarg = DefaultOrthonormalBasis(),
    basis_val::TBval = DefaultOrthonormalBasis(),
) where {
    TAD,
    TR<:AbstractRetractionMethod,
    TIR<:AbstractInverseRetractionMethod,
    TBarg<:AbstractBasis,
    TBval<:AbstractBasis,
}
    return TangentDiffBackend{TAD,TR,TIR,TBarg,TBval}(
        diff_backend,
        retraction,
        inverse_retraction,
        basis_arg,
        basis_val,
    )
end

function differential(M::AbstractManifold, f, t::Real, backend::TangentDiffBackend)
    p = f(t)
    onb_coords = _derivative(zero(number_eltype(p)), backend.diff_backend) do h
        return get_coordinates(
            M,
            p,
            inverse_retract(M, p, f(t + h), backend.inverse_retraction),
            backend.basis_val,
        )
    end
    return get_vector(M, p, onb_coords, backend.basis_val)
end

function differential!(M::AbstractManifold, f, X, t::Real, backend::TangentDiffBackend)
    p = f(t)
    onb_coords = _derivative(zero(number_eltype(p)), backend.diff_backend) do h
        return get_coordinates(
            M,
            p,
            inverse_retract(M, p, f(t + h), backend.inverse_retraction),
            backend.basis_val,
        )
    end
    return get_vector!(M, X, p, onb_coords, backend.basis_val)
end

@doc raw"""
    gradient(M, f, p, backend::TangentDiffBackend)

This method uses the internal `backend.diff_backend` (Euclidean) on the function

```math
    f(\operatorname{retr}_p(\cdot))
```

which is given on the tangent space. In detail, the gradient can be written in
terms of the `backend.basis_arg`. We illustrate it here for an [AbstractOrthonormalBasis](https://juliamanifolds.github.io/Manifolds.jl/stable/interface.html#ManifoldsBase.AbstractOrthonormalBasis),
since that simplifies notations:

```math
\operatorname{grad}f(p) = \operatorname{grad}f(p) = \sum_{i=1}^{d} g_p(\operatorname{grad}f(p),X_i)X_i
	= \sum_{i=1}^{d} Df(p)[X_i]X_i
```

where the last equality is due to the definition of the gradient as the Riesz representer of the differential.

If the backend is a forward (or backward) finite difference, these coefficients in the sum can be approximates as

```math
DF(p)[Y] ≈ \frac{1}{h}\bigl( f(\exp_p(hY)) - f(p) \bigr)
```
writing ``p=\exp_p(0)`` we see that this is a finite difference of ``f\circ\exp_p``, i.e. for
a function on the tangent space, so we can also use other (Euclidean) backends
"""
function gradient(M::AbstractManifold, f, p, backend::TangentDiffBackend)
    X = get_coordinates(M, p, zero_vector(M, p), backend.basis_arg)
    onb_coords = _gradient(X, backend.diff_backend) do Y
        return f(retract(M, p, get_vector(M, p, Y, backend.basis_arg), backend.retraction))
    end
    return get_vector(M, p, onb_coords, backend.basis_arg)
end

function gradient!(M::AbstractManifold, f, X, p, backend::TangentDiffBackend)
    X2 = get_coordinates(M, p, zero_vector(M, p), backend.basis_arg)
    onb_coords = _gradient(X2, backend.diff_backend) do Y
        return f(retract(M, p, get_vector(M, p, Y, backend.basis_arg), backend.retraction))
    end
    return get_vector!(M, X, p, onb_coords, backend.basis_arg)
end

@doc raw"""
    RiemannianProjectionBackend <: AbstractRiemannianDiffBackend

This backend computes the differentiation in the embedding, which is currently limited
to the gradient. Let ``mathcal M`` denote a manifold embedded in some ``R^m``, where ``m``
is usually (much) larger than the manifold dimension.
Then we require three tools

* A function ``f̃: ℝ^m → ℝ`` such that its restriction to the manifold yields the cost
  function ``f`` of interest.
* A [`project`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/projections.html#ManifoldsBase.project-Tuple{AbstractManifold,%20Any,%20Any}) function to project tangent vectors from the embedding (at ``T_pℝ^m``)
  back onto the tangent space ``T_p\mathcal M``. This also includes possible changes
  of the representation of the tangent vector (e.g. in the Lie algebra or in a different data format).
* A [`change_representer`](https://juliamanifolds.github.io/Manifolds.jl/stable/manifolds/metric.html#Manifolds.change_metric-Tuple{AbstractManifold,%20AbstractMetric,%20Any,%20Any}) for non-isometrically embedded manifolds,
  i.e. where the tangent space ``T_p\mathcal M`` of the manifold does not inherit
  the inner product from restriction of the inner product from the tangent space ``T_pℝ^m``
  of the embedding

see also [`riemannian_gradient`](@ref) and [AbsilMahonySepulchre:2008](@cite), Section 3.6.1 for a derivation on submanifolds.
"""
struct RiemannianProjectionBackend{TADBackend} <: AbstractRiemannianDiffBackend
    diff_backend::TADBackend
end

function gradient(
    M::AbstractManifold,
    f,
    p,
    backend::RiemannianProjectionBackend;
    kwargs...,
)
    amb_grad = _gradient(f, p, backend.diff_backend)
    return riemannian_gradient(M, p, amb_grad; kwargs...)
end

function gradient!(
    M::AbstractManifold,
    f,
    X,
    p,
    backend::RiemannianProjectionBackend;
    kwargs...,
)
    amb_grad = embed(M, p, X)
    _gradient!(f, amb_grad, p, backend.diff_backend)
    riemannian_gradient!(M, X, p, amb_grad; kwargs...)
    return X
end


"""
    hessian(M::AbstractManifold, f, p, backend::TangentDiffBackend)

Compute the Hessian of function `f` at point `p` using the given `backend`. The formula
for normal coordinate systems from[^SommerFletcherPennec2020] is used.

[^SommerFletcherPennec2020]:
    > S. Sommer, T. Fletcher, and X. Pennec, “1 - Introduction to differential and Riemannian
    > geometry,” in Riemannian Geometric Statistics in Medical Image Analysis, X. Pennec,
    > S. Sommer, and T. Fletcher, Eds. Academic Press, 2020, pp. 3–37.
    > doi: 10.1016/B978-0-12-814725-2.00008-X.
"""
function hessian(M::AbstractManifold, f, p, backend::TangentDiffBackend)
    X = get_coordinates(M, p, zero_vector(M, p), backend.basis_arg)
    onb_coords = _hessian(X, backend.diff_backend) do Y
        return f(exp(M, p, get_vector(M, p, Y, backend.basis_arg)))
    end
    return onb_coords
end

function jacobian(
    M_dom::AbstractManifold,
    M_codom::AbstractManifold,
    f,
    p,
    backend::TangentDiffBackend,
)
    X = get_coordinates(M_dom, p, zero_vector(M_dom, p), backend.basis_arg)
    q = f(p)
    onb_coords = _jacobian(X, backend.diff_backend) do Y
        return get_coordinates(
            M_codom,
            q,
            inverse_retract(
                M_codom,
                q,
                f(
                    retract(
                        M_dom,
                        p,
                        get_vector(M_dom, p, Y, backend.basis_arg),
                        backend.retraction,
                    ),
                ),
                backend.inverse_retraction,
            ),
            backend.basis_val,
        )
    end
    return onb_coords
end

@doc raw"""
    riemannian_gradient(M, p, Y; embedding_metric=EuclideanMetric())
    riemannian_gradient!(M, X, p, Y; embedding_metric=EuclideanMetric())

For a given gradient ``Y = \operatorname{grad} \tilde f(p)`` in the embedding of a manifold,
this function computes the Riemannian gradient ``\operatorname{grad} f(p)`` of the function
``\tilde f`` restricted to the manifold ``M``.
This can also be done in place of `X`.

By default it uses the following computation:
Let the projection ``Z = \operatorname{proj}_{T_p\mathcal M}(Y)`` of ``Y`` onto the
tangent space at ``p`` be given, that is with respect to the inner product in the embedding.
Then

```math
⟨Z-Y, W⟩ = 0 \text{ for all } W \in T_p\mathcal M,
```

or rearranged ``⟨Y,W⟩ = ⟨Z,W⟩``. We then use the definition of the Riemannian gradient

```math
⟨\operatorname{grad} f(p), W⟩_p = Df(p)[X] = ⟨\operatorname{grad}f(p), W⟩ = ⟨\operatorname{proj}_{T_p\mathcal M}(\operatorname{grad}f(p)),W⟩
\quad\text{for all } W \in T_p\mathcal M.
```
Comparing the first and the last term, the remaining computation is the function [`change_representer`](https://juliamanifolds.github.io/Manifolds.jl/stable/manifolds/metric.html#Manifolds.change_metric-Tuple{AbstractManifold,%20AbstractMetric,%20Any,%20Any}).

This method can also be implemented directly, if a more efficient/stable version is known.

The function is inspired by `egrad2rgrad` in the [Matlab package Manopt](https://manopt.org).
"""
function riemannian_gradient(
    M::AbstractManifold,
    p,
    Y;
    embedding_metric::AbstractMetric = EuclideanMetric(),
)
    X = zero_vector(M, p)
    riemannian_gradient!(M, X, p, Y; embedding_metric = embedding_metric)
    return X
end

function riemannian_gradient!(
    M::AbstractManifold,
    X,
    p,
    Y;
    embedding_metric::AbstractMetric = EuclideanMetric(),
)
    project!(M, X, p, Y)
    change_representer!(M, X, embedding_metric, p, X)
    return X
end

@doc raw"""
    riemannian_Hessian(M, p, eG, eH, X)
    riemannian_Hessian!(M, Y, p, eG, eH, X)

Convert the Euclidean Hessian `eH=```\operatorname{Hess} \tilde f(p) [X]``
of a function ``f \colon \mathcal M \to \mathbb R``, which is the restriction of ``\tilde f`` to ``\mathcal M``,
given additionally the (Euclidean) gradient ``\operatorname{grad} \tilde f(p)``.

The Riemannian Hessian is then computed by

```math
\operatorname{Hess} f(p)[X]
= \operatorname{proj}_{T_p\mathcal M}\bigl(\operatorname{Hess} \tilde f(p)[X])
+ \mathcal W_p\Bigl( X, \operatorname{proj}_{N_p\mathcal M}\bigl( \operatorname{grad} \tilde f (p) \bigr) \Bigr),
```

where ``N_p\mathcal M`` denotes the normal space, i.e. the orthogonal complement of the tangent space in the embedding,
and ``\mathcal W_p`` denotes the [`Weingarten`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions/#ManifoldsBase.Weingarten-Tuple{AbstractManifold,%20Any,%20Any,%20Any}) map. See [Boumal:2023](@cite) for more details

The function is inspired by `ehess2rhess` in the [Matlab package Manopt](https://manopt.org).
"""
function riemannian_Hessian(M::AbstractManifold, p, eG, eH, X)
    Y = zero_vector(M, p)
    riemannian_Hessian!(M, Y, p, eG, eH, X)
    return Y
end
function riemannian_Hessian!(M::AbstractManifold, Y, p, eG, eH, X)
    project!(M, Y, p, eH) #first term - project the Euclidean Hessian
    Y .+= Weingarten(M, p, X, eG - project(M, p, eG))
    return Y
end

using Manifolds, ManifoldDiff, ManifoldsBase, Test
import ManifoldsBase: Weingarten!
Weingarten!(::Sphere, Y::Vector, p::Vector, X::Vector, V::Vector) = (Y .= -X * (p' * V))

@testset "Gradients" begin
    M = Sphere(2)
    p = [0.0, 0.0, 1.0]
    q = [0.0, 1.0, 0.0]
    r = [1.0, 0.0, 0.0]
    @testset "Gradient of the distance function" begin
        X = zero_vector(M, p)
        ManifoldDiff.grad_distance!(M, X, p, q)
        Y = ManifoldDiff.grad_distance(M, p, q)
        Z = [0.0, 0.0, -π / 2] # known solution
        @test X == Y
        @test X == Z
        U = zero_vector(M, p)
        ManifoldDiff.grad_distance!(M, U, p, q, 1)
        V = ManifoldDiff.grad_distance(M, p, q, 1)
        W = -distance(M, q, p)^(-1) * log(M, q, p) # solution
        @test U == V
        @test U == W
        w = q
        U = zero_vector(M, w)
        ManifoldDiff.grad_distance!(M, U, w, q, 1)
        V = ManifoldDiff.grad_distance(M, w, q, 1)
        W = zero_vector(M, w) # solution
        @test U == V
        @test U == W
    end
    @testset "Riemannian Gradient / Hessian Conversion" begin
        M = Sphere(2)
        E = ℝ^3
        A = [1.0 0.1 0.2; 0.1 2.0 0.3; 0.2 0.3 3.0]
        ef(E, p) = 1 / 2 * p'A * p
        grad_ef(E, p) = A * p
        grad_f(M, p) = A * p - (p'A * p) * p
        Hess_ef(E, p, X) = A * X
        Hess_f(M, p, X) = A * X - (p' * A * X) .* p - (p' * A * p) .* X

        p = [1.0, 0.0, 0.0]
        X = [0.0, 0.1, 0.2]

        Y1 = riemannian_gradient(M, p, grad_ef(E, p))
        Y2 = grad_f(M, p)
        @test isapprox(M, p, Y1, Y2)

        Z1 = riemannian_Hessian(M, p, grad_ef(E, p), Hess_ef(M, p, X), X)
        Z2 = Hess_f(M, p, X)
        @test isapprox(M, p, Z1, Z2)
    end
end

using Manifolds, ManifoldDiff, Test, ManifoldsBase

using ManifoldDiff:
    adjoint_differential_exp_argument,
    adjoint_differential_exp_argument!,
    adjoint_differential_exp_basepoint,
    adjoint_differential_exp_basepoint!,
    adjoint_differential_log_argument,
    adjoint_differential_log_argument!,
    adjoint_differential_log_basepoint,
    adjoint_differential_log_basepoint!,
    adjoint_differential_shortest_geodesic_endpoint,
    adjoint_differential_shortest_geodesic_endpoint!,
    adjoint_differential_shortest_geodesic_startpoint,
    adjoint_differential_shortest_geodesic_startpoint!


@testset "Differentials (on Sphere(2))" begin
    # The Adjoint Differentials test using the same variables as the differentials
    # test
    p = [1.0, 0.0, 0.0]
    q = [0.0, 1.0, 0.0]
    M = Sphere(2)
    X = log(M, p, q)
    # Tept differentials (1) Dp of Log_pq
    Y = similar(X)
    @test adjoint_differential_log_basepoint(M, p, p, X) == -X
    adjoint_differential_log_basepoint!(M, Y, p, p, X)
    @test Y == -X
    @test adjoint_differential_log_argument(M, p, p, X) == X
    adjoint_differential_log_argument!(M, Y, p, p, X)
    @test Y == X
    @test adjoint_differential_exp_basepoint(M, p, zero_vector(M, p), X) == X
    adjoint_differential_exp_basepoint!(M, Y, p, zero_vector(M, p), X)
    @test Y == X
    @test adjoint_differential_exp_argument(M, p, zero_vector(M, p), X) == X
    adjoint_differential_exp_argument!(M, Y, p, zero_vector(M, p), X)
    @test Y == X
    for t in [0, 0.15, 0.33, 0.66, 0.9]
        @test adjoint_differential_shortest_geodesic_startpoint(M, p, p, t, X) ==
              (1 - t) * X
        adjoint_differential_shortest_geodesic_startpoint!(M, Y, p, p, t, X)
        @test Y == (1 - t) * X
        @test norm(
            M,
            p,
            adjoint_differential_shortest_geodesic_endpoint(M, p, p, t, X) - t * X,
        ) ≈ 0 atol = 10.0^(-16)
        adjoint_differential_shortest_geodesic_endpoint!(M, Y, p, p, t, X)
        @test norm(M, p, Y - t * X) ≈ 0 atol = 10.0^(-16)
    end
    Mp = PowerManifold(M, NestedPowerRepresentation(), 3)
    pP = [p, q, p]
    qP = [p, p, q]
    XP = [X, zero_vector(M, p), -X]
    YP = similar.(XP)
    ZP = [[0.0, π / 2, 0.0], [0.0, 0.0, 0.0], [π / 2, 0.0, 0.0]]
    @test adjoint_differential_log_argument(Mp, pP, qP, XP) == ZP
    adjoint_differential_log_argument!(Mp, YP, pP, qP, XP)
    @test ZP == YP

    Mprod = ProductManifold(M, M, M)
    pP = ArrayPartition(p, q, p)
    qP = ArrayPartition(p, p, q)
    XP = ArrayPartition(X, zero_vector(M, p), -X)
    YP = allocate(XP)
    ZP = ArrayPartition([0.0, π / 2, 0.0], [0.0, 0.0, 0.0], [π / 2, 0.0, 0.0])
    @test adjoint_differential_log_argument(Mprod, pP, qP, XP) == ZP
    adjoint_differential_log_argument!(Mprod, YP, pP, qP, XP)
    @test ZP == YP

end

@testset "Adjoint differentials on the Circle" begin
    M = Circle()
    p = 0
    q = π / 4
    X = π / 8
    @test adjoint_differential_log_argument(M, p, q, X) == X
end
@testset "Adjoint differentials on Euclidean()" begin
    M = Euclidean()
    p = 0
    q = π / 4
    X = π / 8
    @test adjoint_differential_log_argument(M, p, q, X) == X
end

@doc raw"""
    grad_distance(M, q, p[, c=2])
    grad_distance!(M, X, q, p[, c=2])

compute the (sub)gradient of the distance (default: squared), in place of `X`.

```math
f(p) = \frac{1}{c} d^c_{\mathcal M}(p, q)
```

to a fixed point `q` on the manifold `M` and `c` is an
integer. The (sub-)gradient reads

```math
\operatorname{grad}f(p) = -d_{\mathcal M}^{c-2}(p, q)\log_pq
```

for ``c\neq 1`` or ``p\neq  q``. Note that for the remaining case ``c=1``,
``p=q``, the function is not differentiable. In this case, the function returns the
corresponding zero tangent vector, since this is an element of the subdifferential.

# Optional

* `c` – (`2`) the exponent of the distance,  i.e. the default is the squared
  distance
"""
function grad_distance(M, q, p, c::Int = 2)
    if c == 2
        return -log(M, p, q)
    elseif c == 1 && p == q
        return zero_vector(M, p)
    else
        return -distance(M, p, q)^(c - 2) * log(M, p, q)
    end
end
function grad_distance!(M, X, q, p, c::Int = 2)
    log!(M, X, p, q)
    if c == 2
        X .*= -one(eltype(X))
    elseif c == 1 && p == q
        X = zero_vector(M, p)
    else
        X .*= -distance(M, p, q)^(c - 2)
    end
    return X
end

using Manifolds, ManifoldDiff
using Test
using LinearAlgebra

using ManifoldDiff:
    differential_exp_argument, differential_inverse_retract_argument_fd_approx

@testset "Rotations(3)" begin
    M = Rotations(3)
    p = rand(M)
    X = rand(M; vector_at = p)
    Y = rand(M; vector_at = p)

    @test differential_exp_argument(M, p, X, Y) ≈
          invoke(differential_exp_argument, Tuple{AbstractManifold,Any,Any,Any}, M, p, X, Y)


    G = SpecialOrthogonal(3)
    p = Matrix(I, 3, 3)

    ω = [[1.0, 2.0, 3.0], [3.0, 2.0, 1.0], [1.0, 3.0, 2.0]]
    pts = [exp(M, p, hat(M, p, ωi)) for ωi in ω]
    Xpts = [hat(M, p, [-1.0, 2.0, 0.5]), hat(M, p, [1.0, 0.0, 0.5])]
end

@testset "FiniteDifferenceLogDiffArgumentMethod" begin
    M = Sphere(2)
    p = [1.0, 0.0, 0.0]
    q = [0.0, sqrt(2) / 2, sqrt(2) / 2]
    X = [1.0, -2.0, 2.0]

    # computed using Manopt.differential_log_argument(M, p, q, X)
    diff_ref = [-5.131524956784507e-33, -3.84869943477634, 2.434485872403245]
    @test isapprox(
        M,
        q,
        differential_inverse_retract_argument_fd_approx(M, p, q, X; h = 1e-4),
        diff_ref;
        atol = 1e-7,
    )
end

module ManifoldDiff

using Markdown: @doc_str
using LinearAlgebra

using ManifoldsBase
# using ChainRulesCore
# using RecursiveArrayTools

using ManifoldsBase:
    AbstractBasis,
    AbstractMetric,
    EuclideanMetric,
    TangentSpaceType,
    PowerManifoldNested,
    PowerManifoldNestedReplacing,
    Weingarten,
    allocate_result,
    get_iterator,
    _write,
    _read

using Requires

using ADTypes:
    AbstractADType,
    AutoFiniteDiff,
    AutoFiniteDifferences,
    AutoForwardDiff,
    AutoReverseDiff,
    AutoZygote
import DifferentiationInterface as DI

struct NoneDiffBackend end

"""
    _derivative(f, t[, backend])

Compute the derivative of a callable `f` at time `t` computed using the given `backend`. If the backend is not explicitly
specified, it is obtained using the function [`default_differential_backend`](@ref).

This function calculates plain Euclidean derivatives, for Riemannian differentiation see
for example [`differential`](@ref differential(::AbstractManifold, ::Any, ::Real, ::AbstractRiemannianDiffBackend)).

!!! note

    Not specifying the backend explicitly will usually result in a type instability
    and decreased performance.
"""
function _derivative end

_derivative(f, t) = _derivative(f, t, default_differential_backend())

function _derivative!(f, X, t, backend = default_differential_backend())
    return copyto!(X, _derivative(f, t, backend))
end

"""
    _gradient(f, p[, backend])

Compute the gradient of a callable `f` at point `p` computed using the given `backend`. If the backend is not explicitly
specified, it is obtained using the function [`default_differential_backend`](@ref).

This function calculates plain Euclidean gradients, for Riemannian gradient calculation see
for example [`gradient`](@ref gradient(::AbstractManifold, ::Any, ::Any, ::AbstractRiemannianDiffBackend)).

!!! note

    Not specifying the backend explicitly will usually result in a type instability
    and decreased performance.
"""
function _gradient end

_gradient(f, p) = _gradient(f, p, default_differential_backend())

function _gradient!(f, X, p, backend = default_differential_backend())
    return copyto!(X, _gradient(f, p, backend))
end

"""
    _hessian(f, p[, backend])

Compute the Hessian of a callable `f` at point `p` computed using the given `backend`. If the backend is not explicitly
specified, it is obtained using the function [`default_differential_backend`](@ref).

This function calculates plain Euclidean Hessian.

!!! note

    Not specifying the backend explicitly will usually result in a type instability
    and decreased performance.
"""
function _hessian end

_hessian(f, p) = _hessian(f, p, default_differential_backend())

"""
    _jacobian(f, p[, backend])

Compute the Jacobian of a callable `f` at point `p` computed using the given `backend`. If the backend is not explicitly
specified, it is obtained using the function [`default_differential_backend`](@ref).

This function calculates plain Euclidean Jacobians, for Riemannian Jacobian calculation see
for example [`gradient`](@ref gradient(::AbstractManifold, ::Any, ::Any, ::AbstractRiemannianDiffBackend)).

!!! note

    Not specifying the backend explicitly will usually result in a type instability
    and decreased performance.
"""
function _jacobian end

_jacobian(f, p) = _jacobian(f, p, default_differential_backend())

function _jacobian!(f, X, p, backend = default_differential_backend())
    return copyto!(X, _jacobian(f, p, backend))
end

"""
    CurrentDiffBackend(backend)

A mutable struct for storing the current differentiation backend in a global
constant [`_current_default_differential_backend`](@ref).

# See also

[`default_differential_backend`](@ref), [`set_default_differential_backend!`](@ref)
"""
mutable struct CurrentDiffBackend
    backend::Any
end

"""
    _current_default_differential_backend

The instance of [`CurrentDiffBackend`](@ref) that stores the globally default
differentiation backend.
"""
const _current_default_differential_backend = CurrentDiffBackend(NoneDiffBackend())
"""
    default_differential_backend()

Get the default differentiation backend.
"""
default_differential_backend() = _current_default_differential_backend.backend

"""
    set_default_differential_backend!(backend)

Set current backend for differentiation to `backend`.
"""
function set_default_differential_backend!(backend)
    _current_default_differential_backend.backend = backend
    return backend
end

include("differentiationinterface.jl")

include("diagonalizing_projectors.jl")

include("adjoint_differentials.jl")
include("derivatives.jl")
include("differentials.jl")
include("gradients.jl")
include("Jacobi_fields.jl")
include("proximal_maps.jl")
include("subgradients.jl")
include("jacobians.jl")

include("riemannian_diff.jl")
include("embedded_diff.jl")



function __init__()
    # There is likely no way to set defaults without Requires.jl
    @require FiniteDifferences = "26cc04aa-876d-5657-8c51-4c34ba976000" begin
        using .FiniteDifferences: central_fdm
        if default_differential_backend() === NoneDiffBackend()
            set_default_differential_backend!(AutoFiniteDifferences(central_fdm(5, 1)))
        end
    end

    @require ForwardDiff = "f6369f11-7733-5829-9624-2563aa707210" begin
        if default_differential_backend() === NoneDiffBackend()
            set_default_differential_backend!(AutoForwardDiff())
        end
    end

    @require FiniteDiff = "6a86dc24-6348-571c-b903-95158fe2bd41" begin
        if default_differential_backend() === NoneDiffBackend()
            set_default_differential_backend!(AutoFiniteDiff())
        end
    end

    @require ReverseDiff = "37e2e3b7-166d-5795-8a7a-e32c996b4267" begin
        if default_differential_backend() === NoneDiffBackend()
            set_default_differential_backend!(AutoReverseDiff())
        end
    end

    @require Zygote = "e88e6eb3-aa80-5325-afca-941959d7151f" begin
        if default_differential_backend() === NoneDiffBackend()
            set_default_differential_backend!(AutoZygote())
        end
    end

    return nothing
end

export riemannian_gradient,
    riemannian_gradient!,
    riemannian_Hessian,
    riemannian_Hessian!,
    subgrad_distance,
    subgrad_distance!
export set_default_differential_backend!, default_differential_backend

export TangentDiffBackend, RiemannianProjectionBackend

end # module

@doc raw"""
    Y = geodesic_derivative(M, p, X, t::Number; γt = geodesic(M, p, X, t))
    geodesic_derivative!(M, Y, p, X, t::Number; γt = geodesic(M, p, X, t))

Evaluate the derivative of the geodesic ``γ(t)`` with ``γ_{p,X}(0) = p`` and ``\dot γ_{p,X}(0) = X`` at ``t``.
The formula reads

```math
\dot γ(t) = \mathcal P_{γ(t) \gets p} X
```

where $\mathcal P$ denotes the parallel transport.
This computation can also be done in-place of ``Y``.

# Optional Parameters

* `γt` – (`geodesic(M, p, X, t)`) the point on the geodesic at ``t``.
  This way if the point was computed earlier it can be resued here.
"""
function geodesic_derivative(M, p, X, t::Number; q = geodesic(M, p, X, t))
    return parallel_transport_to(M, p, X, q)
end
function geodesic_derivative!(M, Y, p, X, t::Number; q = geodesic(M, p, X, t))
    parallel_transport_to!(M, Y, p, X, q)
    return Y
end

@doc raw"""
    Y = shortest_geodesic_derivative(M, p, X, t::Number; γt = shortest_geodesic(M, p, q, t))
    shortest_geodesic_derivative!(M, Y, p, X, t::Number; γt = shortest_geodesic(M, p, q, t))

Evaluate the derivative of the shortest geodesic ``γ(t)`` with ``γ_{p,q}(0) = p`` and ``\dot γ_{p,q}(1) = q``
at ``t``.
The formula reads

```math
\dot γ(t) = \mathcal P_{γ(t) \gets p} \log_pq
```

where $\mathcal P$ denotes the parallel transport.
This computation can also be done in-place of ``Y``.

# Optional Parameters

* `γt = geodesic(M, p, X, t)` the point on the geodesic at ``t``.
  This way if the point was computed earlier it can be resued here.
"""
function shortest_geodesic_derivative(
    M,
    p,
    q,
    t::Number;
    γt = shortest_geodesic(M, p, q, t),
)
    return parallel_transport_to(M, p, log(M, p, q), γt)
end
function shortest_geodesic_derivative!(
    M,
    Y,
    p,
    q,
    t::Number;
    γt = shortest_geodesic(M, p, q, t),
)
    log!(M, Y, p, q)
    parallel_transport_to!(M, Y, p, Y, γt)
    return Y
end

using Manifolds, ManifoldsBase, ManifoldDiff, Test
using FiniteDifferences: FiniteDifferences

function finitedifferences_jacobian(
    M_arg::AbstractManifold,
    M_val::AbstractManifold,
    f,
    p;
    B_arg::AbstractBasis = DefaultOrthonormalBasis(),
    B_val::AbstractBasis = DefaultOrthonormalBasis(),
    m = central_fdm(5, 1),
)
    fv = f(p)
    function fj(_c)
        Y = get_vector(M_arg, p, _c, B_arg)
        return get_coordinates(M_val, fv, log(M_val, fv, f(exp(M_arg, p, Y))), B_val)
    end
    return FiniteDifferences.jacobian(m, fj, zeros(manifold_dimension(M_arg)))[1]
end

@testset "Jacobians" begin
    M = Sphere(2)
    p = [0.0, 0.0, 1.0]
    X = [0.0, 1.0, 0.0]
    q = [0.0, 1.0, 0.0]

    Jfnd = finitedifferences_jacobian(TangentSpace(M, p), M, Y -> exp(M, p, Y), X)

    J = ManifoldDiff.jacobian_exp_argument(M, p, X)
    @test J ≈ Jfnd atol = 1e-8

    ManifoldDiff.differential_exp_argument(M, p, X, [1.0, 0.0, 0.0])

    Jc = similar(J)
    ManifoldDiff.jacobian_exp_argument!(M, Jc, p, X)
    @test Jc ≈ Jfnd atol = 1e-8

    Jfnd = finitedifferences_jacobian(
        M,
        M,
        q -> exp(M, q, parallel_transport_to(M, p, X, q)),
        p,
    )
    J = ManifoldDiff.jacobian_exp_basepoint(M, p, X)
    @test J ≈ Jfnd atol = 1e-8

    Jc = similar(J)
    ManifoldDiff.jacobian_exp_basepoint!(M, Jc, p, X)
    @test Jc ≈ Jfnd atol = 1e-8

    Jfnd = finitedifferences_jacobian(M, TangentSpace(M, p), q -> log(M, p, q), q)

    J = ManifoldDiff.jacobian_log_argument(M, p, q)
    @test J ≈ Jfnd atol = 1e-8

    Jc = similar(J)
    ManifoldDiff.jacobian_log_argument!(M, Jc, p, q)
    @test Jc ≈ Jfnd atol = 1e-8

    Jref = finitedifferences_jacobian(
        M,
        TangentSpace(M, p),
        r -> parallel_transport_to(M, r, log(M, r, q), p),
        p,
    )
    J = ManifoldDiff.jacobian_log_basepoint(M, p, q)
    @test J ≈ Jref atol = 1e-8

    Jc = similar(J)
    ManifoldDiff.jacobian_log_basepoint!(M, Jc, p, q)
    @test Jc ≈ Jref atol = 1e-8
end

"""
    allocate_jacobian(
        M_domain::AbstractManifold,
        M_codomain::AbstractManifold,
        f,
        p;
        basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
        basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
    )

Allocate Jacobian of function `f` with given domain and codomain at point `p`.
`basis_domain` and `basis_codomain` denote bases of tangent spaces at, respectively, `p` and `f(p)`.
"""
function allocate_jacobian(
    M_domain::AbstractManifold,
    M_codomain::AbstractManifold,
    f,
    p;
    basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
    basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
)
    n = number_of_coordinates(M_domain, basis_domain)
    m = number_of_coordinates(M_codomain, basis_codomain)
    J = zeros(float(number_eltype(p)), n, m)
    return J
end

function jacobian_exp_argument!(
    M::AbstractManifold,
    J::AbstractMatrix,
    p,
    X,
    basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
    basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
)
    Bb = get_basis(M, p, basis_domain)
    Vs = get_vectors(M, p, Bb)
    Z = similar(X)
    p_exp = exp(M, p, X)
    for i in 1:length(Vs)
        differential_exp_argument!(M, Z, p, X, Vs[i])
        get_coordinates!(M, view(J, :, i), p_exp, Z, basis_codomain)
    end
    return J
end

@doc raw"""
    jacobian_exp_argument(
        M::AbstractManifold,
        p,
        X,
        basis_domain::AbstractBasis=DefaultOrthonormalBasis(),
        basis_codomain::AbstractBasis=DefaultOrthonormalBasis(),
    )

Compute Jacobian of the exponential map with respect to its argument (tangent vector).
Differential of the exponential map is here considered as a function from ``T_p \mathcal{M}``
to ``T_{\exp_p X} \mathcal{M}``. Jacobian coefficients are represented in basis `basis_domain`
in the domain and in `basis_codomain` in the codomain.
"""
function jacobian_exp_argument(
    M::AbstractManifold,
    p,
    X,
    basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
    basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
)
    J = allocate_jacobian(
        M,
        M,
        jacobian_exp_argument,
        X;
        basis_domain = basis_domain,
        basis_codomain = basis_codomain,
    )
    jacobian_exp_argument!(M, J, p, X, basis_domain, basis_codomain)
    return J
end

function jacobian_exp_basepoint!(
    M::AbstractManifold,
    J::AbstractMatrix,
    p,
    X,
    basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
    basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
)
    Bb = get_basis(M, p, basis_domain)
    Vs = get_vectors(M, p, Bb)
    Z = similar(X)
    p_exp = exp(M, p, X)
    for i in 1:length(Vs)
        differential_exp_basepoint!(M, Z, p, X, Vs[i])
        get_coordinates!(M, view(J, :, i), p_exp, Z, basis_codomain)
    end
    return J
end

@doc raw"""
    jacobian_exp_basepoint(
        M::AbstractManifold,
        p,
        X,
        basis_domain::AbstractBasis=DefaultOrthonormalBasis(),
        basis_codomain::AbstractBasis=DefaultOrthonormalBasis(),
    )

Compute Jacobian of the exponential map with respect to the basepoint.
Differential of the exponential map is here considered as a function from ``T_p \mathcal{M}``
to ``T_{\exp_p X} \mathcal{M}``. Jacobian coefficients are represented in basis `basis_domain`
in the domain and in `basis_codomain` in the codomain.
"""
function jacobian_exp_basepoint(
    M::AbstractManifold,
    p,
    X,
    basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
    basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
)
    J = allocate_jacobian(
        M,
        M,
        jacobian_exp_basepoint,
        X;
        basis_domain = basis_domain,
        basis_codomain = basis_codomain,
    )
    jacobian_exp_basepoint!(M, J, p, X, basis_domain, basis_codomain)
    return J
end

function jacobian_log_argument!(
    M::AbstractManifold,
    J::AbstractMatrix,
    p,
    q,
    basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
    basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
)
    Bb = get_basis(M, q, basis_domain)
    Vs = get_vectors(M, q, Bb)
    Z = zero_vector(M, p)
    for i in 1:length(Vs)
        differential_log_argument!(M, Z, p, q, Vs[i])
        get_coordinates!(M, view(J, :, i), p, Z, basis_codomain)
    end
    return J
end

@doc raw"""
    jacobian_log_argument(
        M::AbstractManifold,
        p,
        q,
        basis_domain::AbstractBasis=DefaultOrthonormalBasis(),
        basis_codomain::AbstractBasis=DefaultOrthonormalBasis(),
    )

Compute Jacobian of the logarithmic map with respect to its argument (point `q`).
Differential of the logarithmic map is here considered as a function from ``T_q \mathcal{M}``
to ``T_p \mathcal{M}``. Jacobian coefficients are represented in basis `basis_domain`
in the domain and in `basis_codomain` in the codomain.
"""
function jacobian_log_argument(
    M::AbstractManifold,
    p,
    q,
    basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
    basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
)
    J = allocate_jacobian(
        M,
        M,
        jacobian_log_argument,
        q;
        basis_domain = basis_domain,
        basis_codomain = basis_codomain,
    )
    jacobian_log_argument!(M, J, p, q, basis_domain, basis_codomain)
    return J
end

function jacobian_log_basepoint!(
    M::AbstractManifold,
    J::AbstractMatrix,
    p,
    q,
    basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
    basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
)
    Bb = get_basis(M, p, basis_domain)
    Vs = get_vectors(M, p, Bb)
    Z = zero_vector(M, p)
    for i in 1:length(Vs)
        differential_log_basepoint!(M, Z, p, q, Vs[i])
        get_coordinates!(M, view(J, :, i), p, Z, basis_codomain)
    end
    return J
end

@doc raw"""
    jacobian_log_basepoint(
        M::AbstractManifold,
        p,
        q,
        basis_domain::AbstractBasis=DefaultOrthonormalBasis(),
        basis_codomain::AbstractBasis=DefaultOrthonormalBasis(),
    )

Compute Jacobian of the logarithmic map with respect to the basepoint.
Differential of the logarithmic map is here considered as a function from ``T_q \mathcal{M}``
to ``T_p \mathcal{M}``. Jacobian coefficients are represented in basis `basis_domain`
in the domain and in `basis_codomain` in the codomain.
"""
function jacobian_log_basepoint(
    M::AbstractManifold,
    p,
    q,
    basis_domain::AbstractBasis = DefaultOrthonormalBasis(),
    basis_codomain::AbstractBasis = DefaultOrthonormalBasis(),
)
    J = allocate_jacobian(
        M,
        M,
        jacobian_log_basepoint,
        q;
        basis_domain = basis_domain,
        basis_codomain = basis_codomain,
    )
    jacobian_log_basepoint!(M, J, p, q, basis_domain, basis_codomain)
    return J
end

@doc raw"""
    subgrad_distance(M, q, p[, c = 2; atol = 0])
    subgrad_distance!(M, X, q, p[, c = 2; atol = 0])

compute the subgradient of the distance (in place of `X`)

```math
f(p) = \frac{1}{c} d^c_{\mathcal M}(p, q)
```

to a fixed point `q` on the manifold `M` and `c` is an
integer. The subgradient reads

```math
\partial f(p) = -d_{\mathcal M}^{c-2}(p, q)\log_pq
```

for ``c\neq 1`` or ``p\neq  q``. Note that for the remaining case ``c=1``,
``p=q``, the function is not differentiable. In this case, the subgradient is given by a tangent vector at `p` with norm less than or equal to one.

# Optional

* `c` – (`2`) the exponent of the distance,  i.e. the default is the distance
* `atol` – (`0`) the tolerance to use when evaluating the distance between `p` and `q`.
"""
function subgrad_distance(M, q, p, c::Int = 2; atol = zero(number_eltype(p)))
    if c == 2
        return -log(M, p, q)
    elseif c == 1 && distance(M, q, p) ≤ atol
        return normal_cone_vector(M, p)
    else
        return -distance(M, p, q)^(c - 2) * log(M, p, q)
    end
end
function subgrad_distance!(M, X, q, p, c::Int = 2; atol = zero(number_eltype(p)))
    log!(M, X, p, q)
    if c == 2
        X .*= -one(number_eltype(X))
    elseif c == 1 && distance(M, q, p) ≤ atol
        normal_cone_vector!(M, X, p)
    else
        X .*= -distance(M, p, q)^(c - 2)
    end
    return X
end
function normal_cone_vector(M, p)
    Y = rand(M; vector_at = p)
    if norm(M, p, Y) > one(number_eltype(Y))
        Y ./= norm(M, p, Y)
        Y .*= rand()
    end
    return Y
end
function normal_cone_vector!(M, Y, p)
    ManifoldsBase.rand!(M, Y; vector_at = p)
    if norm(M, p, Y) > one(number_eltype(Y))
        Y ./= norm(M, p, Y)
        Y .*= rand()
    end
    return Y
end

@doc raw"""
    adjoint_differential_shortest_geodesic_startpoint(M, p, q, t, X)
    adjoint_differential_shortest_geodesic_startpoint!(M, Y, p, q, t, X)

Compute the adjoint of ``D_p γ(t; p, q)[X]`` (in place of `Y`).

# See also

[`differential_shortest_geodesic_startpoint`](@ref), [`adjoint_Jacobi_field`](@ref)
"""
function adjoint_differential_shortest_geodesic_startpoint(M::AbstractManifold, p, q, t, X)
    return adjoint_Jacobi_field(M, p, q, t, X, βdifferential_shortest_geodesic_startpoint)
end
function adjoint_differential_shortest_geodesic_startpoint!(
    M::AbstractManifold,
    Y,
    p,
    q,
    t,
    X,
)
    return adjoint_Jacobi_field!(
        M,
        Y,
        p,
        q,
        t,
        X,
        βdifferential_shortest_geodesic_startpoint,
    )
end

@doc raw"""
    adjoint_differential_shortest_geodesic_endpoint(M, p, q, t, X)
    adjoint_differential_shortest_geodesic_endpoint!(M, Y, p, q, t, X)

Compute the adjoint of ``D_q γ(t; p, q)[X]`` (in place of `Y`).

# See also

[`differential_shortest_geodesic_endpoint`](@ref), [`adjoint_Jacobi_field`](@ref)
"""
function adjoint_differential_shortest_geodesic_endpoint(M::AbstractManifold, p, q, t, X)
    return adjoint_Jacobi_field(
        M,
        q,
        p,
        1 - t,
        X,
        βdifferential_shortest_geodesic_startpoint,
    )
end
function adjoint_differential_shortest_geodesic_endpoint!(
    M::AbstractManifold,
    Y,
    p,
    q,
    t,
    X,
)
    return adjoint_Jacobi_field!(
        M,
        Y,
        q,
        p,
        1 - t,
        X,
        βdifferential_shortest_geodesic_startpoint,
    )
end

@doc raw"""
    adjoint_differential_exp_basepoint(M, p, X, Y)
    adjoint_differential_exp_basepoint!(M, Z, p, X, Y)

Computes the adjoint of ``D_p \exp_p X[Y]`` (in place of `Z`).

# See also

[`differential_exp_basepoint`](@ref), [`adjoint_Jacobi_field`](@ref)
"""
function adjoint_differential_exp_basepoint(M::AbstractManifold, p, X, Y)
    return adjoint_Jacobi_field(M, p, exp(M, p, X), 1.0, Y, βdifferential_exp_basepoint)
end
function adjoint_differential_exp_basepoint!(M::AbstractManifold, Z, p, X, Y)
    return adjoint_Jacobi_field!(M, Z, p, exp(M, p, X), 1.0, Y, βdifferential_exp_basepoint)
end

@doc raw"""
    adjoint_differential_exp_argument(M, p, X, Y)
    adjoint_differential_exp_argument!(M, Z, p, X, Y)

Compute the adjoint of ``D_X\exp_p X[Y]`` (in place of `Z`).
Note that ``X ∈  T_p(T_p\mathcal M) = T_p\mathcal M`` is still a tangent vector.

# See also

[`differential_exp_argument`](@ref), [`adjoint_Jacobi_field`](@ref)
"""
function adjoint_differential_exp_argument(M::AbstractManifold, p, X, Y)
    return adjoint_Jacobi_field(M, p, exp(M, p, X), 1.0, Y, βdifferential_exp_argument)
end
function adjoint_differential_exp_argument!(M::AbstractManifold, Z, p, X, Y)
    return adjoint_Jacobi_field!(M, Z, p, exp(M, p, X), 1.0, Y, βdifferential_exp_argument)
end

@doc raw"""
    adjoint_differential_log_basepoint(M, p, q, X)
    adjoint_differential_log_basepoint!(M, Y, p, q, X)

computes the adjoint of ``D_p log_p q[X]`` (in place of `Y`).

# See also
[`differential_log_basepoint`](@ref), [`adjoint_Jacobi_field`](@ref)
"""
function adjoint_differential_log_basepoint(M::AbstractManifold, p, q, X)
    return adjoint_Jacobi_field(M, p, q, 0.0, X, βdifferential_log_basepoint)
end
function adjoint_differential_log_basepoint!(M::AbstractManifold, Y, p, q, X)
    return adjoint_Jacobi_field!(M, Y, p, q, 0.0, X, βdifferential_log_basepoint)
end

@doc raw"""
    adjoint_differential_log_argument(M, p, q, X)
    adjoint_differential_log_argument!(M, Y, p, q, X)

Compute the adjoint of ``D_q log_p q[X]`` (in place of `Y`).

# See also
[`differential_log_argument`](@ref), [`adjoint_Jacobi_field`](@ref)
"""
function adjoint_differential_log_argument(M::AbstractManifold, p, q, X)
    # order of p and q has to be reversed in this call, cf. Persch, 2018 Lemma 2.3
    return adjoint_Jacobi_field(M, q, p, 1.0, X, βdifferential_log_argument)
end
function adjoint_differential_log_argument!(M::AbstractManifold, Y, p, q, X)
    return adjoint_Jacobi_field!(M, Y, q, p, 1.0, X, βdifferential_log_argument)
end

using Test
using LinearAlgebra
using ManifoldDiff
using ForwardDiff: ForwardDiff
using FiniteDifferences: FiniteDifferences
using Manifolds
using ManifoldsBase
using RecursiveArrayTools

@testset "ManifoldDiff.jl" begin
    include("test_differentials.jl")
    include("test_adjoint_differentials.jl")
    include("differentiation.jl")
    include("manifold_specializations.jl")
    include("test_gradients.jl")
    include("test_derivatives.jl")
    include("test_proximal_maps.jl")
    include("test_subgradients.jl")
    include("test_jacobians.jl")
end

# ManifoldDiff

The package __ManifoldDiff__ aims to provide automatic calculation of Riemannian gradients of functions defined on manifolds. It builds upon [`Manifolds.jl`](https://github.com/JuliaManifolds/Manifolds.jl).

## Naming scheme

Providing a derivative, differential or gradient for a given function, this package adds that information to the function name.
For example

* `grad_f` for a gradient ``\operatorname{grad} f``
* `subgrad_f` for a subgradient from the subdifferential``\partial f``
* `differential_f` for ``Df`` (also called pushforward)
* `differential_f_variable` if `f` has multiple variables / parameters, since a usual writing in math is ``f_x`` in this case
* `adjoint_differential_f` for pullbacks
* `adjoint_differential_f_variable` if `f` has multiple variables / parameters
* `f_derivative` for ``f'``
* `jacobian_f` for Jacobian matrix of ``f``.
* `jacobian_f_variable` if `f` has multiple parameters.

the scheme is not completely fixed but tries to follow the mathematical notation.

# Basic usage

You can calculate Riemannian gradient of a function defined in its embedding in multiple ways.
[`DifferentiationInterface.jl`](https://github.com/JuliaDiff/DifferentiationInterface.jl) can be used to select the backend.

```@example
using ManifoldDiff
using DifferentiationInterface
using Manifolds, FiniteDifferences, ForwardDiff, Zygote

rb_onb_fd51 = TangentDiffBackend(AutoFiniteDifferences(central_fdm(5, 1)))
rb_onb_fwdd = TangentDiffBackend(AutoForwardDiff())
rb_proj_zyg = RiemannianProjectionBackend(AutoZygote())

s2 = Sphere(2)

A = [1.0 2.0 5.0; 2.0 -1.0 4.0; 5.0 4.0 0.0]

f(p) = p' * A * p
q = [0.0, 1.0, 0.0]

println(ManifoldDiff.gradient(s2, f, q, rb_onb_fd51))
println(ManifoldDiff.gradient(s2, f, q, rb_onb_fwdd))
println(ManifoldDiff.gradient(s2, f, q, rb_proj_zyg))
```

In this example `rb_onb_fd51` corresponds to a finite differencing scheme, `rb_onb_fwdd` calculates gradient using [`ForwardDiff.jl`](https://github.com/JuliaDiff/ForwardDiff.jl) and `rb_proj_zyg` uses [`Zygote.jl`](https://github.com/FluxML/Zygote.jl) for reverse mode automatic differentiation.

[`TangentDiffBackend`](@ref) reduces dimensionality of the problem to the intrinsic dimension of the manifold, while [`RiemannianProjectionBackend`](@ref) relies on converting Euclidean gradient in the embedding to the Riemannian one.

# Differentiation backends

```@docs
set_default_differential_backend!
default_differential_backend
```

## Euclidian backends

Euclidian backend objects can be taken from [ADTypes.jl](https://github.com/SciML/ADTypes.jl).
See the documentation of [DifferentiationInterface.jl](https://github.com/JuliaDiff/DifferentiationInterface.jl) for the list of supported packages.

## EmbeddedDiff

```@autodocs
Modules = [ManifoldDiff]
Pages = ["embedded_diff.jl"]
Order = [:type, :function, :constant]
```

## Internal functions

```@docs
ManifoldDiff.CurrentDiffBackend
ManifoldDiff._current_default_differential_backend
ManifoldDiff._hessian
ManifoldDiff._jacobian
ManifoldDiff._gradient
ManifoldDiff._derivative
```

# Different library functions

Documentation for `ManifoldDiff.jl`'s methods and types for finite differences and automatic differentiation.

## Derivatives

```@autodocs
Modules = [ManifoldDiff]
Pages = ["derivatives.jl"]
Order = [:type, :function, :constant]
Private = true
```

## Differentials and their adjoints

```@autodocs
Modules = [ManifoldDiff]
Pages = ["adjoint_differentials.jl","differentials.jl"]
Order = [:type, :function, :constant]
Private = true
```

```@autodocs
Modules = [ManifoldDiff]
Pages = ["diagonalizing_projectors.jl"]
Order = [:type, :function, :constant]
Private = true
```

## Gradients

```@autodocs
Modules = [ManifoldDiff]
Pages = ["gradients.jl"]
Order = [:type, :function, :constant]
Private = true
```

## Jacobi fields

```@autodocs
Modules = [ManifoldDiff]
Pages = ["Jacobi_fields.jl"]
Order = [:type, :function, :constant]
```

## Jacobians

```@autodocs
Modules = [ManifoldDiff]
Pages = ["jacobians.jl"]
Order = [:type, :function, :constant]
```

## Riemannian differentials

```@autodocs
Modules = [ManifoldDiff]
Pages = ["riemannian_diff.jl"]
Order = [:type, :function, :constant]
```

## Proximal Maps

Given a convex, lower semi-continuous function ``f\colon \mathcal M \to \mathbb R``, its proximal map is defined
for some ``λ>0`` as [Bacak:2014](@cite)

```math
\operatorname{prox}_{λf}(p) := \operatorname*{arg\,min}_{q\in\mathcal M} \frac{1}{2λ}d^2_{\mathcal M}(p,q) + f(q).
```

Another name for the proximal map is _resolvent_.
Intuitively this means to minimize the function ``f`` while at the same timme “staying close”
to the argument ``p``.

```@autodocs
Modules = [ManifoldDiff]
Pages = ["proximal_maps.jl"]
Order = [:type, :function, :constant]
```
